package com.pranjal.calendarnotificationprovider;

import android.content.Context;

import com.google.gson.Gson;
import com.pranjal.calendarnotificationprovider.models.Constants2;
import com.pranjal.calendarnotificationprovider.models.DynamicText;
import com.pranjal.calendarnotificationprovider.models.EventKeys;
import com.pranjal.calendarnotificationprovider.models.SharedPrefKeys;

import java.text.SimpleDateFormat;
import java.util.Calendar;

import static java.text.DateFormat.getDateTimeInstance;

public class NotificationContentManager {
    static String getTitle(Context context, SharedPrefsManager prefsManager,String title,String description,String startTime,String endTime) {
        String temp = prefsManager.getPreferences(Constants2.sharedPrefKeys.get(SharedPrefKeys.title),"");
        DynamicText dynamicText = new Gson().fromJson(temp,DynamicText.class);
        String res = dynamicText.start;
        res += getMiddleText(dynamicText.middle,title,description,startTime,endTime);
        res += dynamicText.end;
        return res;
    }

    static String getDescription(Context context, SharedPrefsManager prefsManager,String title,String description,String startTime,String endTime) {
        String temp = prefsManager.getPreferences(Constants2.sharedPrefKeys.get(SharedPrefKeys.description),"");
        DynamicText dynamicText = new Gson().fromJson(temp,DynamicText.class);
        if(dynamicText==null)
            return "";
        String res = dynamicText.start;
        res += getMiddleText(dynamicText.middle,title,description,startTime,endTime);
        res += dynamicText.end;
        return res;
    }

    static String getAppOpenName(Context context,SharedPrefsManager prefsManager){
        return prefsManager.getPreferences(Constants2.sharedPrefKeys.get(SharedPrefKeys.OnClickAppName),"");
    }


    private static String getMiddleText(EventKeys ek,String title,String description,String startTime,String endTime){
        if(ek==EventKeys.Empty)
            return "";
        if(ek==EventKeys.Title)
            return title;
        if(ek==EventKeys.Description)
            return description;
        if(ek==EventKeys.TimeLeft){
            return "something";   // edit this
        }
        if(ek==EventKeys.RangeTime){
            return getDate(Long.parseLong(startTime),"hh:mm:ss")+" - "+getDate(Long.parseLong(endTime),"hh:mm:ss");
        }
        return "";
    }

    public static String getDate(long milliSeconds, String dateFormat)
    {
        // Create a DateFormatter object for displaying date in specified format.
        SimpleDateFormat formatter = new SimpleDateFormat(dateFormat);

        // Create a calendar object that will convert the date and time value in milliseconds to date.
        Calendar calendar = Calendar.getInstance();
        calendar.setTimeInMillis(milliSeconds);
        return formatter.format(calendar.getTime());
    }

}
