import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:calendarnotificationprovider/calendarnotificationprovider.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    try {
      platformVersion = await Calendarnotificationprovider.platformVersion;
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }
    try{
      await Calendarnotificationprovider.setPackageName("com.example.sample");
    } on PlatformException{
      print('error occured');
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Calendar Notification App'),
        ),
        body: Center(
          child: InkWell(
              onTap: () async{
                try{
                  await Calendarnotificationprovider.setDescription(start: "Time:- ",end: "",text: DynamicTextEventKeys.RangeTime);
                  await Calendarnotificationprovider.setTitle(start: 'Event:- ',text: DynamicTextEventKeys.Title);
                } on PlatformException{
                  print('error occured');
                }
              },
              child: Text('Running on: $_platformVersion\n')),
        ),
      ),
    );
  }
}
