import 'dart:async';

import 'package:flutter/services.dart';

enum DynamicTextEventKeys{
  Title,
  Description,
  TimeLeft,
  RangeTime,
  Empty
}

class Calendarnotificationprovider {



  static const MethodChannel _channel =
      const MethodChannel('calendarnotificationprovider');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static setPackageName(String name) async {
    await _channel.invokeMethod('setPackageName',name);

  }

  static setAppOpenName(String name) async {
    await _channel.invokeMethod('setAppOpenName',name);
  }

  static setTitle({String start="",String end="",DynamicTextEventKeys text}) async {
    await _channel.invokeMethod('setTitle',<dynamic>[start,_getTextFromDynamicTextKey(text),end]);
  }

  static setDescription({String start="",String end="",DynamicTextEventKeys text}) async {
    await _channel.invokeMethod('setDescription',<dynamic>[start,_getTextFromDynamicTextKey(text),end]);
  }

  static setSmallIcon(String name) async {
    await _channel.invokeMethod('setAppOpenName',name);
  }

  static setLargeIcon(String name) async {
    await _channel.invokeMethod('setAppOpenName',name);
  }

  static _getTextFromDynamicTextKey(DynamicTextEventKeys key){
    switch(key){

      case DynamicTextEventKeys.Title:
        return 'Title';
      case DynamicTextEventKeys.Description:
        return 'Description';
      case DynamicTextEventKeys.TimeLeft:
        return 'TimeLeft';
      case DynamicTextEventKeys.RangeTime:
        return 'RangeTime';
      case DynamicTextEventKeys.Empty:
        return "";
        break;
    }
    return "";
  }


}
